USES CRT, DOS;
(*
 Ŀ
  High Level Extended Memory Calls for Turbo Pascal, Should work with      
  versions 4.0 and above, but tested with Borland's Turbo Pascal 5.5.      
                                                                           
  This program which may be converted to a unit gives all of the functions 
  which should concern the application programmer in moving data to and    
  from XMS memory.  It also renders "C like" functions to write address    
  data in hex to screen or file.                                           
                                                                           
  Victor E. Cummings                                                       
  AstroSoft Data Systems, Inc.                                             
  P.O. Box 12295                                                           
  Baltimore, Maryland 21281                                                
  (301) 675-3607                                                           
                                                                           
  Compile Using TPC XMS                                                    
                                                                           
 *)
{$F+} (* Go ahead and take this out if you like to reboot! *)

TYPE

MoveStruct = RECORD
    Len           : LONGINT;  { dd  ?   ; 32-bit number of bytes to transfer   }
    SourceHandle  : WORD;     { dw  ?   ; Handle of source block               }
    SourceOffset  : POINTER;  { dd  ?   ; 32-bit offset into source            }
    DestHandle    : WORD;     { dw  ?   ; Handle of destination block          }
    DestOffset    : POINTER;  { dd  ?   ; 32-bit offset into destination block }
END;

    WordString = STRING [ 4 ];
    VerString  = STRING [ 5 ];

VAR

ERROR    : WORD;
HANDLE   : WORD;
REQUEST  : WORD;
STATUS   : WORD;
REGS     : REGISTERS;
MoveRec  : MoveStruct;
HelloStr : STRING;
CH       : CHAR;

FUNCTION CutSp ( Passed_String : STRING ) : STRING;
VAR
   i,
   j       : INTEGER;
BEGIN
     j := LENGTH ( Passed_String );

     WHILE ( Passed_String [ j ] = ' ') AND (j > 0) DO
        j := j - 1;

     Passed_String [ 0 ] := CHR ( j );

     CutSp := Passed_String;
END;

FUNCTION HexWord ( i : INTEGER ) : WordString;
CONST

hc : array[0..15] of Char = '0123456789ABCDEF';

VAR

l, h : BYTE;

BEGIN
  l := LO ( i ); h := HI ( i );
  HexWord := hc [ h SHR 4 ] + hc [ h AND $F ] +
  hc [ l SHR 4 ] + hc [ l AND $F ];
  END;

(*
Ŀ
   XMSInstalled : BOOLEAN                                                   
                                                                            
   GAZINTAS:>NONE                                                          
   GAZOWTAS:  RETURNS True if XMS is installed.                             
*)
FUNCTION XMSInstalled: BOOLEAN;
VAR
REGS : REGISTERS;
BEGIN
  WITH REGS DO
    BEGIN
      AH := $43;
      AL := $00;
      INTR ($2f, REGS);
      IF (AL = $80) THEN XMSInstalled := TRUE
        ELSE XMSInstalled := FALSE;
    END;
END;

{$L XMM.OBJ} (* Assembler module assembled using Borland TASM 2.5 *)
             (* TASM XMM *)
(*
Ŀ
   XMMVer   WORD; EXTERNAL                                                  
                                                                            
   GAZINTA :>NONE                                                          
                                                                            
   GAZOWTA :  Returns Version in DECIMAL Converted to BCD int XMSVersion    
*)
FUNCTION XMMVER : INTEGER; EXTERNAL;
(*
Ŀ
   XMMRev : WORD; EXTERNAL                                                  
                                                                            
   GAZINTAS:>NONE                                                          
                                                                            
   GAZOWTAS:  Returns External Revision Number in Decimal.                  
   converted to BCD by XMSRevision.                                         
*)
FUNCTION XMMRev     : INTEGER; EXTERNAL;
(*
Ŀ
   XMMFree : WORD; EXTERNAL                                                 
                                                                            
   GAZINTAS:>NONE                                                          
                                                                            
   GAZOWTAS:  Returns amount of currently free XMS memory in KB.            
*)
FUNCTION XMMFREE    : WORD; EXTERNAL;

(*
Ŀ
   XMMTotal: WORD; EXTERNAL                                                 
                                                                            
   GAZINTAS:>NONE                                                          
                                                                            
   GAZOWTAS:  Returns total amount of XMS memory in KB.                     
*)
FUNCTION XMMTOTAL   : WORD; EXTERNAL;

(*
Ŀ
   XMMMalloc(Requested: WORD): WORD; EXTERNAL                               
                                                                            
   GAZINTAS:>Requested amount in KB                                        
                                                                            
   GAZOWTAS:  Returns status of 1 if successful.                            
*)
FUNCTION XMMALLOC(Requested: WORD) : WORD; EXTERNAL;

(*
Ŀ
   XMMDispose(Handle : WORD): WORD; EXTERNAL                                
                                                                            
   GAZINTAS:>Handle to get rid of                                          
                                                                            
   GAZOWTAS:  Returns status of 1 if successful.                            
*)
FUNCTION XMMDISPOSE(Handle: WORD) : WORD; EXTERNAL;

(*
Ŀ
   XMMDispose(Handle : WORD): WORD; EXTERNAL                                
                                                                            
   GAZINTAS:>Requested amount in KB                                        
                                                                            
   GAZOWTAS:  Returns status of 1 if successful.                            
*)
FUNCTION XMMMOVEMEM: WORD; EXTERNAL;

(*
Ŀ
   XMMLock(Handle : WORD): WORD; EXTERNAL                                   
                                                                            
   GAZINTAS:>Handle to lock                                                
                                                                            
   GAZOWTAS:  Returns status of 1 if successful.                            
*)
FUNCTION XMMLOCK(Handle: WORD)    : WORD; EXTERNAL;

(*
Ŀ
   XMMUnLock(Handle : WORD): WORD; EXTERNAL                                 
                                                                            
   GAZINTAS:>Handle to unlock                                              
                                                                            
   GAZOWTAS:  Returns status of 1 if successful.                            
*)
FUNCTION XMMUNLOCK(Handle : WORD)  : WORD; EXTERNAL;

(*
Ŀ
   XMMGetBlockSize(Handle : WORD): WORD; EXTERNAL                           
                                                                            
   GAZINTAS:>Handle query                                                  
                                                                            
   GAZOWTAS:  Returns amount of memory in KB held by Handle                 
*)
FUNCTION XMMGetBlockSize(Handle : WORD)  : WORD; EXTERNAL;

(*
Ŀ
   XMMGetHandles(Handle : WORD): WORD; EXTERNAL                             
                                                                            
   GAZINTAS:>Handle query                                                  
                                                                            
   GAZOWTAS:  Returns number of free handles in the system                  
*)
FUNCTION XMMGetHandles(Handle : WORD)  : WORD; EXTERNAL;

(*
Ŀ
   XMMRealoc(Handle : WORD; NewSize: WORD): WORD; EXTERNAL                  
                                                                            
   GAZINTAS:>Handle, New Size to make previously allocated block           
                                                                            
   GAZOWTAS:  Returns 1 if successful                                       
*)
FUNCTION XMMREALOC(Handle : WORD; NewSize : WORD)  : WORD; EXTERNAL;

FUNCTION XMMVersion : VerString;
VAR
XMMHIGH    : STRING[2];
XMMLOW     : STRING[2];
TempString : STRING;
  BEGIN
    TempString := HexWord(XMMVer);
    TempString := Cutsp(TempString);
    XMMHIGH    := COPY(TempString,1,2);
    XMMLOW     := COPY(TempString,3,2);
    TempString := XMMHIGH + '.' + XMMLOW;
    IF (COPY(TempString,1,1) = '0') THEN
    TempString := COPY(TempString,2,4);
    XMMVersion := CutSp(TempString);
  END;

FUNCTION XMMRevision: VerString;
VAR
XMMHIGH    : STRING[2];
XMMLOW     : STRING[2];
TempString : STRING;
  BEGIN
    TempString  := HexWord(XMMRev);
    TempString  := Cutsp(TempString);
    XMMHIGH     := COPY(TempString,1,2);
    XMMLOW      := COPY(TempString,3,2);
    TempString  := XMMHIGH + '.' + XMMLOW;
    IF (COPY(TempString,1,1) = '0') THEN
    TempString  := COPY(TempString,2,4);
    XMMRevision := CutSp(TempString);
  END;

BEGIN
  IF XMSInstalled THEN
    BEGIN
      TEXTBACKGROUND(BLUE);
      TEXTCOLOR(WHITE);
      CLRSCR;
      HelloStr := 'Hello world - I came from XMS memory! ';
      WRITELN('XMS Version Number             :   ', XMMVersion);
      WRITELN('XMS Internal Revision Number   :   ', XMMRevision);
      WRITELN('XMS Free Memory  in Kilo Bytes :   ', XMMFREE);
      WRITELN('XMS Total Memory in Kilo Bytes :   ', XMMTOTAL);
      WRITELN('Allocating 256 KB EMB ...');
      WRITELN('Locking EMB Handle');
      HANDLE := XMMALLOC(256);
      STATUS := XMMLOCK(HANDLE);
      WRITELN ('Status of Lock:  ', STATUS);
      WRITELN ('Handle Returned:  ', HANDLE);
      WRITELN('XMS Free Memory in Kilo Bytes after allocation :   ', XMMFREE);
      WRITELN; WRITELN; WRITELN;
      WRITELN ('Press a key to test move functions.');
      CH := READKEY;
      CLRSCR;
      WRITELN('Moving String to allocated block');
      WITH MoveRec DO
      BEGIN
        Len          := LENGTH(HelloStr);
        SourceHandle := 0;
        SourceOffset := PTR(SEG(HelloStr),OFS(HelloStr));
        DestHandle   := HANDLE;
        DestOffset   := PTR(0000,0000);               {Offset into block}
      END;
      WRITELN('String in base memory is now:  ', HelloStr);
      STATUS := XMMMOVEMEM;
      WRITELN ('Status of Move:  ', HexWord(STATUS) );
      WRITELN ('Clearing String in base memory');
      {Create storage of correct size for string!}
      HelloStr := '                                      ';
      WRITELN('String in base memory is now:  ', HelloStr);
      WITH MoveRec DO
      BEGIN
        Len          := LENGTH(HelloStr);
        SourceHandle := HANDLE;
        SourceOffset := PTR(0000,0000);
        DestHandle   := 0;
        DestOffset   := PTR(SEG(HelloStr),OFS(HelloStr));
      END;
      STATUS := XMMMOVEMEM;
      WRITELN ('Status of Move:  ', HexWord(STATUS));
      WRITELN('Printing String: ');
      WRITELN('String in base memory is now:  ', HelloStr);
      WRITELN('UnLocking EMB Handle');
      STATUS := XMMUNLOCK(HANDLE);
      WRITELN ('Status of Unlock:  ', STATUS);
      WRITELN('Adjusting block size closer to data size');
      STATUS := XMMREALOC(HANDLE, 1);
      WRITELN ('Status of reallocation:  ', STATUS);
      WRITELN('Current Block Size:  ', XMMGetBlockSize(Handle), ' KB');
      WRITELN('Number of Free Handles:  ', XMMGetHandles(Handle));
      WRITELN('XMS Free Memory  in Kilo Bytes :   ', XMMFREE);
      WRITELN('Disposing of ', XMMGetBlockSize(Handle), ' KB EMB ...');
      STATUS := XMMDISPOSE (HANDLE);
      WRITELN ('Status:  ', STATUS );
      WRITELN ('Handle Disposed:  ', HANDLE);
      WRITELN('XMS Free Memory  in Kilo Bytes :   ', XMMFREE);
      WRITELN ('Address MoveRec:  ', HexWord(Seg(MoveRec)), ':',
      HexWord(Ofs(MoveRec)));
      CH := READKEY;
      TEXTMODE(C80);
    END
    ELSE
    WRITELN ('Buy some extended memory, or load HIMEM.SYS');
END.
